property spriteCount, theSelection, theClipBoard, spriteMax, outerRect, innerRect
global gObjList, gObj2, gObj3, gObj5, gDialogPresent

on new me
  set spriteMax to 50
  set spriteCount to 0
  set theSelection to []
  set theClipBoard to []
  return me
end

on selectGraphic me, theSprite, fromNewGraphic
  if not fromNewGraphic and the shiftDown then
    set spritePresent to getOne(theSelection, theSprite)
    if spritePresent then
      deleteAt(theSelection, spritePresent)
    else
      add(theSelection, theSprite)
    end if
    if not count(theSelection) then
      deselectAll(me)
      exit
    end if
  else
    if getOne(theSelection, theSprite) then
      if the mouseDown then
        set the pattern of member 62 to 6
      else
        set the pattern of member 62 to the myCounter of getAt(gObjList, 1) + 57
      end if
      if the optionDown then
        set optionDrag to 1
      end if
    else
      set the pattern of member 62 to the myCounter of getAt(gObjList, 1) + 57
      set theSelection to [theSprite]
      if the optionDown then
        set optionDrag to 1
      end if
    end if
  end if
  if count(theSelection) = 1 then
    if the isBalloon of sprite(getAt(theSelection, 1)) then
      enable(sprite(86))
    else
      disable(sprite(86))
    end if
  else
    disable(sprite(86))
  end if
  checkOrder()
  set outerRect to the rect of sprite getAt(theSelection, 1)
  set minH to 9000
  set minV to 9000
  set maxH to -9000
  set maxV to -9000
  repeat with i in theSelection
    set sRect to the rect of sprite i
    set outerRect to union(sRect, outerRect)
    set minH to min(the right of sRect, minH)
    set minV to min(the bottom of sRect, minV)
    set maxH to max(the left of sRect, maxH)
    set maxV to max(the top of sRect, maxV)
  end repeat
  set innerRect to rect(minH - 15, minV - 15, maxH + 15, maxV + 15)
  setSelectRect(me, outerRect)
  if min(theSelection) > 1 then
    enable(sprite(85))
  else
    disable(sprite(85))
  end if
  if max(theSelection) < spriteCount then
    enable(sprite(84))
  else
    disable(sprite(84))
  end if
  enable(sprite(83))
  enable(sprite(87))
  updateStage()
  if fromNewGraphic or not (the mouseDown) then
    exit
  end if
  if optionDrag then
    set previousSelection to duplicate(theSelection)
    set tempClip to []
    copySelection(me, tempClip)
    set theSelection to []
    pasteSelection(me, tempClip)
    if gDialogPresent then
      if not count(theSelection) then
        set theSelection to previousSelection
      end if
      exit
    end if
  end if
  set oldLoc to the clickLoc
  set minH to getAt(the frameRect of gObj2, 1) - (minH - 15 - the locH of the clickLoc)
  set minV to getAt(the frameRect of gObj2, 2) - (minV - 15 - the locV of the clickLoc)
  set maxH to getAt(the frameRect of gObj2, 3) - (maxH + 15 - the locH of the clickLoc)
  set maxV to getAt(the frameRect of gObj2, 4) - (maxV + 15 - the locV of the clickLoc)
  cursor(290)
  set the curs of getAt(gObjList, 1) to 290
  set exitTimer to the ticks + 4
  repeat while 1
    if not (point(the mouseH, the mouseV) = oldLoc) or (the ticks > exitTimer) or the mouseUp then
      exit repeat
    end if
    update(getAt(gObjList, 1), 1)
  end repeat
  if the mouseDown then
    set the pattern of member 62 to 6
  end if
  set constrain to 0
  repeat while the mouseDown
    set newLoc to point(max(minH, min(the mouseH, maxH)), max(minV, min(the mouseV, maxV)))
    update(getAt(gObjList, 1), 1)
    if newLoc = oldLoc then
      next repeat
    end if
    set the imageTouched of gObj2 to 1
    set the documentTouched of gObj5 to 1
    set diff to newLoc - oldLoc
    if the shiftDown and not constrain then
      set constrain to (abs(getAt(diff, 1)) > abs(getAt(diff, 2))) + 1
      setAt(diff, constrain, 0)
    else
      if constrain then
        setAt(diff, constrain, 0)
      end if
    end if
    repeat with i in theSelection
      set the loc of sprite i to the loc of sprite i + diff
    end repeat
    set outerRect to outerRect + rect(diff, diff)
    set innerRect to innerRect + rect(diff, diff)
    setSelectRect(me, outerRect)
    updateStage()
    set oldLoc to newLoc
  end repeat
  set the pattern of member 62 to the myCounter of getAt(gObjList, 1) + 57
end

on deselectAll me, noUpdate
  set theSelection to []
  repeat with i = 54 to 57
    set the locH of sprite i to 9000
  end repeat
  set grayoutList to [83, 84, 85, 86, 87]
  repeat with i in grayoutList
    disable(sprite(i))
  end repeat
  if not noUpdate then
    updateStage()
  end if
  cursor(-1)
  checkOrder()
end

on flipSelection me
  repeat with i in theSelection
    set theNum to the memberNum of sprite i
    if theNum mod 2 then
      set the memberNum of sprite i to theNum + 1
      next repeat
    end if
    set the memberNum of sprite i to theNum - 1
  end repeat
  set the imageTouched of gObj2 to 1
  set the documentTouched of gObj5 to 1
  if theNum mod 2 then
    puppetSound(1, "flipRight")
  else
    puppetSound(1, "flipLeft")
  end if
  updateStage()
end

on deleteSelection me
  if not count(theSelection) then
    exit
  end if
  repeat with i in theSelection
    set the locH of sprite i to 1500
    set isBalloon to the isBalloon of sprite(i)
    if isBalloon then
      setAt(getAt(the balloonList of gObj3, isBalloon), getOne(getAt(the balloonList of gObj3, isBalloon), 0), the balloonID of sprite(i))
      set the isBalloon of sprite(i) to 0
    end if
    set subtractFromSpriteCount to subtractFromSpriteCount + 1
  end repeat
  set start to min(theSelection)
  set end to spriteCount
  repeat with i = start to end
    if the locH of sprite i > 640 then
      repeat with searchForGraphic = i + 1 to spriteCount
        if the locH of sprite searchForGraphic < 640 then
          set the loc of sprite i to the loc of sprite searchForGraphic
          set the isBalloon of sprite(i) to the isBalloon of sprite(searchForGraphic)
          set the balloonID of sprite(i) to the balloonID of sprite(searchForGraphic)
          set the balloonProps of sprite(i) to the balloonProps of sprite(searchForGraphic)
          set the member of sprite i to the member of sprite searchForGraphic
          set the locH of sprite searchForGraphic to 9000
          exit repeat
        end if
      end repeat
    end if
  end repeat
  set spriteCount to spriteCount - subtractFromSpriteCount
  set the imageTouched of gObj2 to 1
  set the documentTouched of gObj5 to 1
  puppetSound(1, "cut")
  deselectAll()
end

on layerSelection me, direction, notFromBtn
  sort(theSelection)
  set theSelection to theSelection * 1
  set selectionTotal to count(theSelection)
  set lastSprite to 100
  if direction = 1 then
    set i to selectionTotal + 1
  else
    set i to 0
  end if
  repeat with n = 1 to selectionTotal
    set i to i - direction
    set theSprite to getAt(theSelection, i)
    if (direction = -1) and (theSprite = (lastSprite + 1)) then
      next repeat
    else
      if theSprite = (lastSprite - 1) then
        next repeat
      end if
    end if
    flipSprites(theSprite, theSprite + direction)
    setAt(theSelection, i, theSprite + direction)
    set lastSprite to theSprite
  end repeat
  if min(theSelection) > 1 then
    enable(sprite(85))
  else
    disable(sprite(85))
  end if
  if max(theSelection) < spriteCount then
    enable(sprite(84))
  else
    disable(sprite(84))
  end if
  set the imageTouched of gObj2 to 1
  set the documentTouched of gObj5 to 1
  updateStage()
  checkOrder()
end

on flipSprites sprite1, sprite2
  set memberData to [the member of sprite sprite1, the loc of sprite sprite1, the isBalloon of sprite(sprite1), the balloonID of sprite(sprite1), the balloonProps of sprite(sprite1)]
  set the member of sprite sprite1 to the member of sprite sprite2
  set the loc of sprite sprite1 to the loc of sprite sprite2
  set the isBalloon of sprite(sprite1) to the isBalloon of sprite(sprite2)
  set the balloonID of sprite(sprite1) to the balloonID of sprite(sprite2)
  set the balloonProps of sprite(sprite1) to the balloonProps of sprite(sprite2)
  set the member of sprite sprite2 to getAt(memberData, 1)
  set the loc of sprite sprite2 to getAt(memberData, 2)
  set the isBalloon of sprite(sprite2) to getAt(memberData, 3)
  set the balloonID of sprite(sprite2) to getAt(memberData, 4)
  set the balloonProps of sprite(sprite2) to getAt(memberData, 5)
end

on setSelectRect me, inputRect
  set theRect to rect(max(305 - ((the pCurrentFrameSize of gObj2 - 1) * 105), getAt(inputRect, 1)), max(2, getAt(inputRect, 2)), min(501 + ((the pCurrentFrameSize of gObj2 - 1) * 105), getAt(inputRect, 3)), min(198, getAt(inputRect, 4)))
  set xSize to the width of theRect
  set ySize to the height of theRect
  set the rect of sprite 54 to theRect - [-1, 0, xSize, 0]
  set the rect of sprite 55 to theRect - [0, -1, 0, ySize]
  set the rect of sprite 56 to theRect + [xSize, 0, -1, 0]
  set the rect of sprite 57 to theRect + [0, ySize, 0, -1]
end

on keyCheck me, key, modifierKeyPressed, dontDeselect
  if modifierKeyPressed then
    case key of
      "n":
        set activateBtn to 89
      "o":
        set activateBtn to 91
      "s":
        set activateBtn to 93
      "p":
        set activateBtn to 95
      "q":
        set activateBtn to 99
      "a":
        if not spriteCount then
          exit
        end if
        set theSelection to []
        repeat with i = 1 to spriteCount
          add(theSelection, i)
        end repeat
        selectGraphic(me, spriteCount, 1)
      "x":
        keyCheck(me, "c", 1)
        deleteSelection()
      "c":
        copySelection(me, theClipBoard)
      "v":
        deselectAll()
        pasteSelection(me, theClipBoard)
    end case
    if activateBtn then
      mouseDown(sprite(activateBtn))
      Del(5)
      mouseUp(sprite(activateBtn))
    end if
  else
    case the key of
      BACKSPACE:
        mouseDown(sprite(87))
        Del(4)
        mouseUp(sprite(87))
      "":
        if count(theSelection) then
          set nudgeDistance to point(-1, 0) * ((the shiftDown * 9) + 1)
        else
          browseThroughFrames(gObj2, -1)
        end if
      "":
        if count(theSelection) then
          set nudgeDistance to point(0, -1) * ((the shiftDown * 9) + 1)
        end if
      "":
        if count(theSelection) then
          set nudgeDistance to point(1, 0) * ((the shiftDown * 9) + 1)
        else
          browseThroughFrames(gObj2, 1)
        end if
      "":
        if count(theSelection) then
          set nudgeDistance to point(0, 1) * ((the shiftDown * 9) + 1)
        end if
      "-":
        mouseDown(sprite(85))
        Del(2)
        mouseUp(sprite(85))
      "=", "+":
        mouseDown(sprite(84))
        Del(2)
        mouseUp(sprite(84))
    end case
    if listp(nudgeDistance) and count(theSelection) then
      set offset to point(min(the right of the frameRect of gObj2 - the right of innerRect, max(the left of innerRect + the locH of nudgeDistance, the left of the frameRect of gObj2) - the left of innerRect), min(the bottom of the frameRect of gObj2 - the bottom of innerRect, max(the top of innerRect + the locV of nudgeDistance, the top of the frameRect of gObj2) - the top of innerRect))
      repeat with i in theSelection
        set the loc of sprite i to the loc of sprite i + offset
      end repeat
      set outerRect to outerRect + rect(offset, offset)
      set innerRect to innerRect + rect(offset, offset)
      setSelectRect(me, outerRect)
      set the imageTouched of gObj2 to 1
      set the documentTouched of gObj5 to 1
      updateStage()
    end if
  end if
  checkOrder()
end

on copySelection me, whereInto
  if not count(theSelection) then
    exit
  end if
  deleteAll(whereInto)
  set tempSelection to duplicate(theSelection)
  sort(tempSelection)
  repeat with i in tempSelection
    add(whereInto, [the memberNum of sprite i, the loc of sprite i, the isBalloon of sprite(i), the balloonProps of sprite(i)])
  end repeat
end

on pasteSelection me, fromWhere
  set end to count(fromWhere)
  if not end then
    exit
  end if
  repeat with i = 1 to end
    if spriteCount < spriteMax then
      set theSpriteProps to getAt(fromWhere, i)
      set spriteCount to spriteCount + 1
      set balloonType to getAt(theSpriteProps, 3)
      if balloonType then
        set balloonSubList to getAt(the balloonList of gObj3, balloonType)
        set balloonID to max(balloonSubList)
        if balloonID then
          setAt(balloonSubList, getOne(balloonSubList, balloonID), 0)
          set the balloonID of sprite(spriteCount) to balloonID
          set the member of sprite spriteCount to member (balloonID + ((getAt(theSpriteProps, 1) mod 2) = 0)) of castLib 3
          set the isBalloon of sprite(spriteCount) to balloonType
          set the balloonProps of sprite(spriteCount) to getAt(theSpriteProps, 4)
          updateBalloonContents(gObj3, spriteCount)
        else
          set reachedBalloonMax to 1
          set spriteCount to spriteCount - 1
          next repeat
        end if
      else
        set the member of sprite spriteCount to member getAt(theSpriteProps, 1) of castLib 3
        set the isBalloon of sprite(spriteCount) to 0
      end if
      set the loc of sprite spriteCount to getAt(theSpriteProps, 2)
      add(theSelection, spriteCount)
      next repeat
    end if
    set overFlow to 1
    exit repeat
  end repeat
  updateStage()
  if count(theSelection) then
    set the imageTouched of gObj2 to 1
    set the documentTouched of gObj5 to 1
    updateStage()
    selectGraphic(me, getAt(theSelection, 1), 1)
  end if
  if overFlow then
    tell window 1
      displayDialog(3)
    end tell
    exit
  else
    if reachedBalloonMax then
      tell window 1
        displayDialog(4)
      end tell
      exit
    end if
  end if
end
