property pageLayoutList, currentFrameNo, pCurrentFrameSize, pCurrentBorderType, frameRect, imageTouched, pFileTitle, pAuthorName, pUnloadList
global gObj1, gObj3, gObj5, gDialogPresent, gPlatForm, g68KThumbnailPatch, gItemSeparator

on new me
  set imageTouched to 0
  set currentFrameNo to 1
  set pageLayoutList to [[1, 1, 0], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
  set pCurrentFrameSize to 1
  set pCurrentBorderType to 1
  duplicate(member (140 + pCurrentFrameSize), member (200 + currentFrameNo) of castLib 2)
  set frameRect to rect(305 - ((pCurrentFrameSize - 1) * 105), 2, 501 + ((pCurrentFrameSize - 1) * 105), 198)
  set pUnloadList to []
  return me
end

on updateTitleAndName me, theTitle, theName
  set pFileTitle to theTitle
  set pAuthorName to theName
  set the text of member "title" to clipText(pFileTitle, 101)
  set the text of member "name" to clipText(pAuthorName, 55)
end

on checkThumbs me
  if gDialogPresent then
    exit
  end if
  if imageTouched and not count(the theSelection of gObj1) then
    if the spriteCount of gObj1 then
      updateThumbNail(me)
      updateThumbNail(me, currentFrameNo)
    else
      duplicate(member (140 + pCurrentFrameSize), member (200 + currentFrameNo) of castLib 2)
      set imageTouched to 0
    end if
  end if
end

on changeBorderType me
  set pCurrentBorderType to (pCurrentBorderType + 1) mod 2
  set imageTouched to 1
  set the documentTouched of gObj5 to 1
  set the memberNum of sprite 62 to 30 + pCurrentFrameSize + (pCurrentBorderType * 2)
  puppetSound(1, "changeBorderType")
  updateStage()
end

on checkBtnStates me
  if pCurrentFrameSize = 1 then
    if (currentFrameNo > 1) and not ((currentFrameNo mod 3) = 1) then
      set frameBeforeIsEmpty to getAt(pageLayoutList, currentFrameNo - 1) = 0
    end if
    if currentFrameNo mod 3 then
      set frameAfterIsEmpty to getAt(pageLayoutList, currentFrameNo + 1) = 0
    end if
    if (frameBeforeIsEmpty = 0) and (frameAfterIsEmpty = 0) then
      disable(sprite(82))
    else
      enable(sprite(82))
    end if
  else
    enable(sprite(82))
  end if
  set smallEmptyPos to getOne(pageLayoutList, 0)
  if pCurrentFrameSize = 2 then
    if not scanForLargeEmptyPos() then
      disable(sprite(81))
    else
      enable(sprite(81))
    end if
  else
    if not smallEmptyPos then
      disable(sprite(81))
    else
      enable(sprite(81))
    end if
  end if
  if not smallEmptyPos then
    disable(sprite(79))
  else
    enable(sprite(79))
  end if
  repeat with i = 1 to 12
    if not integerp(getAt(pageLayoutList, i)) then
      set frameCount to frameCount + 1
    end if
    if frameCount = 2 then
      enable(sprite(80))
      exit repeat
    end if
  end repeat
  if i = 13 then
    disable(sprite(80))
  end if
end

on changeFrameSize me
  set requestedSize to (getAt(getAt(pageLayoutList, currentFrameNo), 1) mod 2) + 1
  if requestedSize = 2 then
    if not (getAt(pageLayoutList, min(12, currentFrameNo + 1)) = 0) or ((currentFrameNo mod 3) = 0) then
      setAt(pageLayoutList, currentFrameNo - 1, duplicate(getAt(pageLayoutList, currentFrameNo)))
      set currentFrameNo to currentFrameNo - 1
    end if
  end if
  puppetSound(1, "changeFrameSize" & requestedSize)
  updateStage()
  setAt(getAt(pageLayoutList, currentFrameNo), 1, requestedSize)
  set pCurrentFrameSize to requestedSize
  set frameRect to rect(305 - ((pCurrentFrameSize - 1) * 105), 2, 501 + ((pCurrentFrameSize - 1) * 105), 198)
  set the memberNum of sprite 62 to 30 + pCurrentFrameSize + (pCurrentBorderType * 2)
  if count(the theSelection of gObj1) then
    selectGraphic(gObj1, getAt(the theSelection of gObj1, 1), 1)
  end if
  if pCurrentFrameSize = 1 then
    setAt(pageLayoutList, currentFrameNo + 1, 0)
  else
    setAt(pageLayoutList, currentFrameNo + 1, 1)
  end if
  set the media of member (200 + currentFrameNo) of castLib 2 to the media of member (140 + pCurrentFrameSize)
  update(sprite(currentFrameNo + 1 + 100))
  update(sprite(currentFrameNo + 100))
  if not getOne(pageLayoutList, 0) then
    disable(sprite(79))
    disable(sprite(81))
  else
    if requestedSize = 2 then
      if not scanForLargeEmptyPos() then
        disable(sprite(81))
      end if
    else
      enable(sprite(79))
      enable(sprite(81))
    end if
  end if
  set imageTouched to 1
  set the documentTouched of gObj5 to 1
  updateThumbNail(me)
  if imageTouched then
    updateThumbNail(me, currentFrameNo)
  end if
  updateStage()
end

on jumpToFrame me, whichFrame, storeData, zoom, noUpdate
  if not noUpdate then
    deselectAll(gObj1, 1)
  end if
  if storeData then
    storeFrameData(me)
  end if
  set previousFrameNo to currentFrameNo
  set currentFrameNo to whichFrame
  if not (currentFrameNo = previousFrameNo) then
    update(sprite(previousFrameNo + 100))
  end if
  if not (zoom = 0) then
    updateStage()
    puppetSound(1, zoom)
    clearFrameLayout(me)
    set zoom to 1
  end if
  retrieveFrameData(me, zoom)
  if zoom then
    zoomBox(currentFrameNo + 100, 117, 1)
    set the locH of sprite 117 to 9000
  end if
  if imageTouched then
    updateThumbNail(me, previousFrameNo)
  end if
  updateStage()
end

on addFrame me
  set vacantPos to scanForSmallEmptyPos()
  setAt(pageLayoutList, vacantPos, [1, 1, 0])
  duplicate(member 141, member (200 + vacantPos) of castLib 2)
  set the documentTouched of gObj5 to 1
  jumpToFrame(me, vacantPos, 1, "jumpToFrameAdd")
end

on duplicateFrame me
  if pCurrentFrameSize = 1 then
    set vacantPos to scanForSmallEmptyPos()
  else
    set vacantPos to scanForLargeEmptyPos()
  end if
  storeFrameData(me)
  if imageTouched then
    updateThumbNail(me, currentFrameNo)
  end if
  setAt(pageLayoutList, vacantPos, duplicate(getAt(pageLayoutList, currentFrameNo)))
  if pCurrentFrameSize = 2 then
    setAt(pageLayoutList, vacantPos + 1, 1)
  end if
  duplicate(member (200 + currentFrameNo) of castLib 2, member (200 + vacantPos) of castLib 2)
  set the documentTouched of gObj5 to 1
  jumpToFrame(me, vacantPos, 0, "jumpToFrameDuplicate")
end

on scanForSmallEmptyPos me
  repeat with i = currentFrameNo to 12
    if getAt(pageLayoutList, i) = 0 then
      exit repeat
    end if
  end repeat
  if i < 13 then
    set vacantPos to i
  else
    set vacantPos to getOne(pageLayoutList, 0)
  end if
  return vacantPos
end

on scanForLargeEmptyPos me
  set firstEmptyPos to 0
  repeat with i = 1 to 11
    if not (i mod 3) then
      next repeat
    end if
    if not (getAt(pageLayoutList, i) = 0) then
      next repeat
    end if
    if getAt(pageLayoutList, i + 1) = 0 then
      if not firstEmptyPos then
        set firstEmptyPos to i
      end if
      set vacantPos to i
      if i > currentFrameNo then
        exit repeat
      end if
      next repeat
    end if
    set i to i + 1
  end repeat
  if vacantPos < currentFrameNo then
    set vacantPos to firstEmptyPos
  end if
  return vacantPos
end

on deleteFrame me
  set frameCount to 0
  repeat with i = 1 to 12
    set framePresent to listp(getAt(pageLayoutList, i))
    if framePresent then
      set frameCount to frameCount + 1
      if i < currentFrameNo then
        set jumpToAfterDelete to i
        next repeat
      end if
      if not (i = currentFrameNo) then
        if not (integerp(jumpToAfterDelete) and (jumpToAfterDelete < currentFrameNo)) then
          set jumpToAfterDelete to i
        end if
      end if
    end if
  end repeat
  setAt(pageLayoutList, currentFrameNo, 0)
  if pCurrentFrameSize = 2 then
    setAt(pageLayoutList, currentFrameNo + 1, 0)
  end if
  set previousFrameNo to currentFrameNo
  set the documentTouched of gObj5 to 1
  jumpToFrame(me, jumpToAfterDelete, 0, "jumpToFrameDelete")
  erase(member (200 + previousFrameNo) of castLib 2)
end

on switchFrames me, fromWhatPosition, toWhatPosition, zoom, duplicateFrame
  set tempList to duplicate(getAt(pageLayoutList, fromWhatPosition))
  if not duplicateFrame then
    setAt(pageLayoutList, fromWhatPosition, 0)
    if getAt(tempList, 1) = 2 then
      setAt(pageLayoutList, fromWhatPosition + 1, 0)
    end if
  end if
  setAt(pageLayoutList, toWhatPosition, tempList)
  if getAt(tempList, 1) = 2 then
    setAt(pageLayoutList, toWhatPosition + 1, 1)
  end if
  if not duplicateFrame then
    move(member (fromWhatPosition + 200) of castLib 2, member (toWhatPosition + 200) of castLib 2)
  else
    duplicate(member (fromWhatPosition + 200) of castLib 2, member (toWhatPosition + 200) of castLib 2)
  end if
  set the documentTouched of gObj5 to 1
  if zoom then
    set zoom to "jumpToFrame"
  end if
  jumpToFrame(me, toWhatPosition, 0, zoom)
  if duplicateFrame then
    duplicate(member (toWhatPosition + 200) of castLib 2, member (fromWhatPosition + 200) of castLib 2)
  end if
end

on storeFrameData me
  if the spriteCount of gObj1 then
    set tempList to [:]
    repeat with i = 1 to the spriteCount of gObj1
      set isBalloon to the isBalloon of sprite(i)
      if isBalloon then
        addProp(tempList, the memberNum of sprite i, [the loc of sprite i, the isBalloon of sprite(i), the balloonProps of sprite(i)])
        next repeat
      end if
      addProp(tempList, the memberNum of sprite i, [the loc of sprite i, 0, 0])
    end repeat
    setAt(pageLayoutList, currentFrameNo, [pCurrentFrameSize, pCurrentBorderType, tempList])
    if imageTouched then
      updateThumbNail(me)
    end if
  else
    setAt(pageLayoutList, currentFrameNo, [pCurrentFrameSize, pCurrentBorderType, 0])
    duplicate(member (140 + pCurrentFrameSize), member (200 + currentFrameNo) of castLib 2)
    set imageTouched to 0
  end if
end

on retrieveFrameData me, zoom
  set pCurrentFrameSize to getAt(getAt(pageLayoutList, currentFrameNo), 1)
  set pCurrentBorderType to getAt(getAt(pageLayoutList, currentFrameNo), 2)
  set frameRect to rect(305 - ((pCurrentFrameSize - 1) * 105), 2, 501 + ((pCurrentFrameSize - 1) * 105), 198)
  checkBtnStates()
  set the memberNum of sprite 62 to 30 + pCurrentFrameSize + (pCurrentBorderType * 2)
  if zoom then
    set the rect of sprite 117 to frameRect
  end if
  update(sprite(100 + currentFrameNo))
  if zoom then
    updateStage()
  end if
  set frameDataList to getAt(getAt(pageLayoutList, currentFrameNo), 3)
  set the balloonList of gObj3 to duplicate(the balloonMasterList of gObj3)
  set i to 1
  if listp(frameDataList) then
    set the spriteCount of gObj1 to count(frameDataList)
    repeat with i = 1 to the spriteCount of gObj1
      set spriteDataList to getAt(frameDataList, i)
      set the loc of sprite i to getAt(spriteDataList, 1)
      set isBalloon to getAt(spriteDataList, 2)
      if isBalloon then
        set balloonSubList to getAt(the balloonList of gObj3, isBalloon)
        set balloonID to max(balloonSubList)
        setAt(balloonSubList, getOne(balloonSubList, balloonID), 0)
        set the isBalloon of sprite(i) to isBalloon
        set the balloonID of sprite(i) to balloonID
        set the balloonProps of sprite(i) to getAt(spriteDataList, 3)
        set the member of sprite i to member (balloonID + not (getPropAt(frameDataList, i) mod 2)) of castLib 3
        updateBalloonContents(gObj3, i)
        next repeat
      end if
      set the isBalloon of sprite(i) to 0
      set theM to getPropAt(frameDataList, i)
      set thePosInUnloadList to getOne(pUnloadList, theM)
      if thePosInUnloadList then
        deleteAt(pUnloadList, thePosInUnloadList)
      end if
      set the member of sprite i to member theM of castLib 3
    end repeat
  else
    set the spriteCount of gObj1 to 0
  end if
  unloadTheList()
  repeat with s = i to 50
    set the locH of sprite s to 9000
  end repeat
end

on unloadTheList me
  repeat with i in pUnloadList
    unloadMember(member i of castLib 3)
  end repeat
  set pUnloadList to []
end

on updateThumbNail me, forWhichFrame
  if not forWhichFrame then
    if the spriteCount of gObj1 then
      deselectAll(gObj1)
      if gPlatForm and not g68KThumbnailPatch then
        ThumbnailStageB(200, 1, frameRect + [-2, -2, 2, 2])
      else
        set tWidth to 40 + ((pCurrentFrameSize - 1) * 42)
        set error to StageResizeToMember(getAt(frameRect, 1) - 2, getAt(frameRect, 2) - 2, getAt(frameRect, 3) + 2, getAt(frameRect, 4) + 2, tWidth, 40, 200, 1)
        if error then
          alert("CBA/2 internal error: problem with thumbnail!" & RETURN & RETURN & error)
        end if
        if not max(the rect of member 200) then
          duplicate(member (140 + pCurrentFrameSize), member 200 of castLib 1)
        end if
      end if
    else
      duplicate(member (140 + pCurrentFrameSize), member (200 + currentFrameNo) of castLib 2)
      set imageTouched to 0
    end if
  else
    if not (the type of member 200 of castLib 1 = #bitmap) then
      set error to 1
    end if
    if not error then
      set error to max(the rect of member 200 of castLib 1) = 0
    end if
    if error then
      put "Thumbnail update problem" && the ticks
      set imageTouched to 1
      exit
    end if
    set the regPoint of member 200 of castLib 1 to point(0, 0)
    set the media of member (forWhichFrame + 200) of castLib 2 to the media of member 200 of castLib 1
    set the palette of member (200 + currentFrameNo) of castLib 2 to -1
    set imageTouched to 0
  end if
end

on browseThroughFrames me, direction
  set thisFrame to currentFrameNo
  repeat while 1
    set newFrame to ((thisFrame - 1 + direction + 12) mod 12) + 1
    set thisFrame to thisFrame + direction
    if listp(getAt(pageLayoutList, newFrame)) then
      set jumpTo to newFrame
      exit repeat
    end if
  end repeat
  if not (jumpTo = currentFrameNo) then
    jumpToFrame(me, jumpTo, 1, "jumpToFrame")
  end if
end

on editTitleAndName me, fromDialog, theNewTitle, theNewName
  if (the optionDown + the commandDown + the controlDown + gPlatForm) = 4 then
    puppetSound(1, "confirm")
    updateStage()
    Del(30)
    recapPage(me)
  else
    if fromDialog then
      updateTitleAndName(me, theNewTitle, theNewName)
      set the documentTouched of gObj5 to 1
    else
      puppetSound(1, "editTitleAndName")
      tell window 1
        displayDialog(20, pFileTitle, pAuthorName)
      end tell
    end if
  end if
end

on recapPage me, xtraOpened
  repeat with i = the number of xtras down to 1
    if the name of xtra(i) contains "scrnXtra" then
      set found to 1
      exit repeat
    end if
  end repeat
  if not (found + xtraOpened) then
    openXLib("@:supportM:" & "xtra5b")
    Del(120)
    recapPage(me, 1)
    exit
  else
    if xtraOpened then
      alert("No scrnXtra!")
      exit
    end if
  end if
  set g68KThumbnailPatch to 1
  set imageTouched to 1
  repeat with i = 1 to 12
    if listp(getAt(pageLayoutList, i)) then
      if voidp(endFrame) then
        set endFrame to i
      end if
      jumpToFrame(me, i, 1, "jumpToFrame")
      set imageTouched to 1
    end if
  end repeat
  jumpToFrame(me, endFrame, 1, "jumpToFrame")
  set g68KThumbnailPatch to 0
end

on convertPageLayoutList me
  storeFrameData()
  set saveAsSampleFile to (the commandDown + the shiftDown + the optionDown) = 3
  if saveAsSampleFile then
    puppetSound(1, "confirm")
  end if
  set str to pFileTitle & gItemSeparator & pAuthorName & gItemSeparator & the pCharacterCode of gObj5 & gItemSeparator & the pCharLibVersion of gObj5 & gItemSeparator & saveAsSampleFile & gItemSeparator & the pFileVersion of gObj5 & RETURN
  repeat with frame in pageLayoutList
    if listp(frame) then
      put getAt(frame, 1) & gItemSeparator & getAt(frame, 2) & gItemSeparator after str
      set graphicsDataList to getAt(frame, 3)
      if listp(graphicsDataList) then
        repeat with i = 1 to count(graphicsDataList)
          put makeNumber(getPropAt(graphicsDataList, i), 4) after str
          set spriteInfo to getAt(graphicsDataList, i)
          put makeNumber(getAt(getAt(spriteInfo, 1), 1), 4) & makeNumber(getAt(getAt(spriteInfo, 1), 2), 4) after str
          if getAt(spriteInfo, 2) then
            put makeNumber(getAt(spriteInfo, 2), 2) after str
            set balloonData to getAt(spriteInfo, 3)
            put makeNumber(getAt(balloonData, 1), 2) after str
            put makeNumber(getAt(balloonData, 2), 2) after str
            put makeNumber(getAt(balloonData, 3), 2) after str
            put getAt(getAt(balloonData, 4), 1) & the pSchar1 of gObj5 after str
            put stripReturns(getAt(getAt(balloonData, 4), 2), the pReturnChar of gObj5) after str
          end if
          put gItemSeparator after str
        end repeat
      else
        put "0" after str
      end if
    else
      put frame & gItemSeparator after str
    end if
    put RETURN after str
  end repeat
  return str
end

on makePageLayoutList me, input, thisFileVersion
  set tempList1 to []
  set firstFrame to 12
  set end to the number of lines in input - 2
  set the itemDelimiter to gItemSeparator
  repeat with lne = 1 to end
    set frameData to line lne + 1 of input
    if length(frameData) = 2 then
      add(tempList1, value(char 1 of frameData))
      next repeat
    end if
    set tempList2 to [value(item 1 of frameData), value(item 2 of frameData)]
    set firstFrame to min(firstFrame, lne)
    if not (item 3 of frameData = "0") then
      set spriteList to [:]
      set end2 to the number of items in frameData - 1
      repeat with i = 3 to end2
        set thisItem to item i of frameData
        set mNum to value(char 1 to 4 of thisItem)
        set itemLength to length(thisItem)
        if itemLength < 12 then
          if itemLength = 11 then
            if char 8 of thisItem = "-" then
              put "0" after char 4 of thisItem
            else
              if char 5 of thisItem = "-" then
                put "0" after char 8 of thisItem
              end if
            end if
          else
            put "0" after char 7 of thisItem
            put "0" after char 4 of thisItem
          end if
        else
          if (itemLength > 12) and (thisFileVersion = 0) then
            if (value(char 13 to 14 of thisItem) = 0) or (value(char 15 to 16 of thisItem) = 0) then
              if char 8 of thisItem = "-" then
                put "0" after char 4 of thisItem
              else
                if char 5 of thisItem = "-" then
                  put "0" after char 8 of thisItem
                end if
              end if
              set thisItem to char 1 to 12 of thisItem
            else
              put "0" after char 7 of thisItem
              put "0" after char 4 of thisItem
            end if
          end if
        end if
        set mLoc to point(value(char 5 to 8 of thisItem), value(char 9 to 12 of thisItem))
        set dataList to [mLoc, 0, 0]
        if not (itemLength < 13) then
          set balloonType to value(char 13 to 14 of thisItem)
          set typeSize to value(char 15 to 16 of thisItem)
          set lineHeight to value(char 17 to 18 of thisItem)
          set scrollTop to value(char 19 to 20 of thisItem)
          set splitChar to offset(the pSchar1 of gObj5, thisItem)
          set sourceText to char 21 to splitChar - 1 of thisItem
          set balloonText to addReturns(char splitChar + 1 to length(thisItem) of thisItem, the pReturnChar of gObj5)
          set balloonList to [typeSize, lineHeight, scrollTop, [sourceText, balloonText]]
          setAt(dataList, 2, balloonType)
          setAt(dataList, 3, balloonList)
        end if
        addProp(spriteList, mNum, duplicate(dataList))
      end repeat
      add(tempList2, duplicate(spriteList))
    else
      add(tempList2, 0)
    end if
    add(tempList1, duplicate(tempList2))
  end repeat
  set pageLayoutList to tempList1
  updateTitleAndName(me, item 1 of line 1 of input, item 2 of line 1 of input)
  set currentFrameNo to 0
  repeat with i = 1 to 12
    update(sprite(100 + i))
  end repeat
  set currentFrameNo to 1
  jumpToFrame(me, firstFrame, VOID, VOID, 1)
end
