property pDataFolderPath, pPrefFilePath, pMainFolderName, pCharacterFolderName, pCharacterCode, pSampleFileName, pDefaultFileName, documentTouched, pCurrentFileName, pDefaultProjectName, pDataFileDirectoryContents, pLastDirectorySelection, pFileNameExtension, pReturnChar, pSchar1, pCharLibVersion, pFileVersion
global gObj1, gObj2, gPlatForm, gItemSeparator, gOldColorDepth, gTaskBarStatus, gScholasticObj, gLangCode

on new me
  set pFileVersion to 1
  set documentTouched to 0
  set pSchar1 to numToChar(2)
  set pReturnChar to numToChar(3)
  set pCurrentFileName to 0
  set pLastDirectorySelection to 1
  set characterCodeInfo to the name of member 1 of castLib 3
  set pCharacterCode to char 1 of characterCodeInfo
  if pCharacterCode = EMPTY then
    alert("ScreenLib has no ID code!" & RETURN & RETURN & "member 1")
    quit()
  end if
  set pCharLibVersion to value(char 3 to length(characterCodeInfo) of characterCodeInfo)
  if not integerp(pCharLibVersion) or not pCharLibVersion then
    alert("ScreenLib has no fileVersion code!" & RETURN & RETURN & "member 1")
    quit()
  end if
  if gPlatForm then
    set pathNameSeparator to ":"
    set pFileNameExtenstion to EMPTY
  else
    set pathNameSeparator to "\"
    set pFileNameExtension to ".CB" & pCharacterCode
  end if
  set allSettingsString to the text of member 1 of castLib 2
  set the itemDelimiter to "/"
  set pDefaultProjectName to item 1 of line 1 of allSettingsString
  set pMainFolderName to item abs(gPlatForm - 2) of line 6 of allSettingsString & pathNameSeparator
  set pDefaultFileName to item abs(gPlatForm - 2) of line 5 of allSettingsString
  set theString to line 7 to 100 of allSettingsString
  repeat with i = the number of lines in theString down to 1
    if line i of theString starts pCharacterCode & "/" then
      set pCharacterFolderName to item abs(gPlatForm - 2) + 1 of line i of theString & pathNameSeparator
      exit repeat
    end if
  end repeat
  if voidp(pCharacterFolderName) then
    alert("CBA/2 internal error: no foldername to match current charactercode!" & RETURN & pCharacterCode)
  end if
  set pSampleFileName to item abs(gPlatForm - 2) of line 4 of allSettingsString & pFileNameExtension
  checkPrefs(me)
  updateTitleAndName(gObj2, pDefaultProjectName, the pAuthorName of gObj2)
  return me
end

on checkPrefs me
  set allPrefString to readPrefFile()
  set the itemDelimiter to gItemSeparator
  if allPrefString contains pSchar1 & pCharacterCode then
    set startChar to offset(pSchar1 & pCharacterCode, allPrefString) + 2
    set temp to char startChar + 2 to length(allPrefString) of allPrefString
    set endChar to offset(pSchar1, temp) + startChar
    set thisCharacterPrefString to char startChar to endChar of allPrefString
    set the pAuthorName of gObj2 to item 1 of thisCharacterPrefString
    set pDataFolderPath to the last item in thisCharacterPrefString
    set the volume of sound 1 to value(item 2 of thisCharacterPrefString)
  end if
  if not length(string(pDataFolderPath)) then
    set pDataFolderPath to searchDataFolder(me, allPrefString)
  else
    if gPlatForm then
      set directoryValid to OSIsDirectory(pDataFolderPath)
    else
      set directoryValid to baFolderExists(pDataFolderPath)
    end if
    if not (directoryValid = 1) then
      set pDataFolderPath to searchDataFolder(me, allPrefString)
    end if
  end if
  set the itemDelimiter to "/"
  if voidp(the pAuthorName of gObj2) then
    set the pAuthorName of gObj2 to item 1 of line 2 of the text of member 1 of castLib 2
  end if
  set pDataFileDirectoryContents to getAllDataFiles()
  if (pDataFileDirectoryContents = EMPTY) and not (pDataFolderPath contains pCharacterFolderName) then
    set pDataFolderPath to searchDataFolder()
  end if
end

on readPrefFile me, DeleteFile
  set fileObj to new(xtra("fileIO"))
  if gPlatForm then
    set pPrefFilePath to OSSpecialPath("pref") & ":CBA2 preferences"
  else
    set pPrefFilePath to getOSDirectory() & "\CBA2.ini"
  end if
  openFile(fileObj, pPrefFilePath, 1)
  set allPrefs to readFile(fileObj)
  if DeleteFile then
    delete(fileObj)
  else
    closeFile(fileObj)
  end if
  set fileObj to 0
  return allPrefs
end

on searchDataFolder me, allPrefString
  put "searching for dataFolder..."
  set volume to getNthOfPath(getOSDirectory())
  if gPlatForm then
    set trashWord to getNthOfPath(OSSpecialPath("trsh"), 0)
    set foundList to OSSearchTypeCreator(volume, "CBA" & pCharacterCode, "CBA" & pCharacterCode, 10, 0)
    if count(foundList) then
      set subDirectoriesList to [:]
      repeat with i in foundList
        delete char -30002 of i
        put ":" after i
        if i contains trashWord then
          next repeat
        end if
        set entryExists to findPos(subDirectoriesList, i)
        if not entryExists then
          addProp(subDirectoriesList, i, 1)
          next repeat
        end if
        setAt(subDirectoriesList, entryExists, getAt(subDirectoriesList, entryExists) + 1)
      end repeat
      if count(subDirectoriesList) then
        return getOne(subDirectoriesList, max(subDirectoriesList))
      end if
    end if
    if voidp(dataFolderPath) and not voidp(allPrefString) then
      set the itemDelimiter to pSchar1
      set pathOptionsList to EMPTY
      repeat with i = the number of items in allPrefString down to 1
        set thisItem to item i of allPrefString
        if length(thisItem) then
          put thisItem & RETURN after pathOptionsList
        end if
      end repeat
      set the itemDelimiter to gItemSeparator
      repeat with i = the number of lines in pathOptionsList - 1 down to 1
        set pathOption to the last item in line i of pathOptionsList
        if pathOption contains pMainFolderName then
          set pathOption to char 1 to offset(pMainFolderName, pathOption) + length(pMainFolderName) - 1 of pathOption
          if OSIsDirectory(pathOption) = 1 then
            set dataFolderPath to pathOption
            exit repeat
          end if
        end if
      end repeat
    end if
    if voidp(dataFolderPath) then
      set error to OSIsDirectory(volume & pMainFolderName)
      if error = 0 then
        alert("CBA/2 internal error: could not create main directory because a file exists with the same name" & RETURN & error && pMainFolderName)
      else
        if not (error = 1) then
          set error to OSCreateDir(volume, pMainFolderName)
          if error then
            alert("CBA/2 internal error: could not create" && pMainFolderName && "directory!" & RETURN & error)
          end if
        end if
      end if
      set dataFolderPath to volume & pMainFolderName
    end if
    set error to OSIsDirectory(dataFolderPath & pCharacterFolderName)
    if error = 0 then
      alert("CBA/2 internal error: could not create " & pCharacterFolderName && "directory because a file exists with the same name!" & RETURN & error)
    else
      if not (error = 1) then
        set error to OSCreateDir(dataFolderPath, pCharacterFolderName)
        if error then
          alert("CBA/2 internal error: could not create " & pCharacterFolderName && "directory!" & RETURN & error)
        end if
        set dataFolderPath to dataFolderPath & pCharacterFolderName
        if objectp(gScholasticObj) then
          repeat with i = 1 to 3
            set error to OSFileCopy(the moviePath & "supportM:" & pCharacterCode & "_sample." & i, dataFolderPath & pSampleFileName & i)
            if error then
              alert("CBA/2 internal error: could not copy sampleFile!" & RETURN & RETURN & error)
              next repeat
            end if
            OSSetFileInfo(dataFolderPath & pSampleFileName & i, "CBA" & pCharacterCode, "CBA" & pCharacterCode)
          end repeat
        else
          set error to OSFileCopy(the moviePath & "supportM:" & pCharacterCode & "_sample." & gLangCode, dataFolderPath & pSampleFileName)
          if error then
            alert("CBA/2 internal error: could not copy sampleFile!" & RETURN & RETURN & error)
          else
            OSSetFileInfo(dataFolderPath & pSampleFileName, "CBA" & pCharacterCode, "CBA" & pCharacterCode)
          end if
        end if
      else
        set dataFolderPath to dataFolderPath & pCharacterFolderName
      end if
    end if
  else
    set programFilesPath to baReadRegString("Software\Microsoft\Windows\CurrentVersion\", "ProgramFilesDir", EMPTY, "HKEY_LOCAL_MACHINE") & "\"
    if not baFolderExists(programFilesPath & pMainFolderName & pCharacterFolderName) then
      set Ok to baCreateFolder(programFilesPath & pMainFolderName & pCharacterFolderName)
      if not Ok then
        alert("CBA/2 internal error: cannot create directory " & pMainFolderName & pCharacterFolderName)
      end if
      if objectp(gScholasticObj) then
        repeat with i = 1 to 3
          set customSampleFileName to char 1 to length(pSampleFileName) - 4 of pSampleFileName & i & pFileNameExtension
          set error to baCopyFile(the moviePath & "supportW\" & pCharacterCode & "_sample." & i, programFilesPath & pMainFolderName & pCharacterFolderName & customSampleFileName, "IfNotExist")
          if error then
            alert("CBA/2 internal error: problem copying sampleFile!" & RETURN & RETURN & error)
          end if
        end repeat
      else
        set error to baCopyFile(the moviePath & "supportW\" & pCharacterCode & "_sample." & gLangCode, programFilesPath & pMainFolderName & pCharacterFolderName & pSampleFileName, "IfNotExist")
        if error then
          alert("CBA/2 internal error: problem copying sampleFile!" & RETURN & RETURN & error & RETURN & RETURN & the moviePath & "supportW\" & pCharacterCode & "_sample." & gLangCode)
        end if
      end if
      set error to baCopyFile(the moviePath & "supportW\" & pCharacterCode & "_icon", programFilesPath & pMainFolderName & pCharacterFolderName & pCharacterCode & "_icon", "IfNotExist")
      if error then
        alert("CBA/2 internal error: problem copying iconFile!" & RETURN & RETURN & error)
      end if
      baSetFileAttributes(programFilesPath & pMainFolderName & pCharacterFolderName & pCharacterCode & "_icon", "h")
    end if
    set dataFolderPath to programFilesPath & pMainFolderName & pCharacterFolderName
  end if
  return dataFolderPath
end

on writePrefFile me, dataString
  if not length(string(pCharacterCode)) then
    exit
  end if
  set allPrefString to readPrefFile(me, 1)
  if not length(string(allPrefString)) then
    set allPrefString to pSchar1
  else
    if allPrefString contains pSchar1 & pCharacterCode then
      set startChar to offset(pSchar1 & pCharacterCode, allPrefString)
      set temp to char startChar + 2 to length(allPrefString) of allPrefString
      set endChar to offset(pSchar1, temp) + startChar
      delete char startChar to endChar of allPrefString
    end if
  end if
  set allPrefString to allPrefString & pCharacterCode & dataString & gItemSeparator & pDataFolderPath & pSchar1
  set fileObj to new(xtra("fileIO"))
  createFile(fileObj, pPrefFilePath)
  openFile(fileObj, pPrefFilePath, 2)
  writeString(fileObj, allPrefString)
  if gPlatForm then
    setFinderInfo(fileObj, "pref CBA2")
  end if
  closeFile(fileObj)
  set fileObj to 0
end

on newFile me, fromDialog
  if not checkForChanges() or fromDialog then
    cursor(4)
    set the pageLayoutList of gObj2 to [[1, 1, 0], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]
    set the imageTouched of gObj2 to 0
    set documentTouched to 0
    clearPageLayout()
    clearFrameLayout()
    updateStage()
    repeat with i = 1 to 12
      if i = 1 then
        duplicate(member 141, member (i + 200) of castLib 2)
      else
        erase(member (i + 200) of castLib 2)
      end if
      update(sprite(100 + i))
    end repeat
    updateTitleAndName(gObj2, pDefaultProjectName, the pAuthorName of gObj2)
    set pCurrentFileName to 0
    jumpToFrame(gObj2, 1)
    cursor(0)
  else
    tell window 1
      displayDialog(7, #newFile, me)
    end tell
  end if
end

on getAllDataFiles me
  if gPlatForm then
    set allFilesInDataFolder to OSGetFileNamesinFolder(pDataFolderPath, 0)
    if not stringp(allFilesInDataFolder) then
      return EMPTY
    end if
    set end to the number of lines in allFilesInDataFolder
    set validFilesString to EMPTY
    set validTypeCreatorCombi to "CBA" & pCharacterCode & ",CBA" & pCharacterCode
    repeat with i = 1 to end
      if OSGetFileInfo(pDataFolderPath & line i of allFilesInDataFolder) = validTypeCreatorCombi then
        put line i of allFilesInDataFolder & RETURN after validFilesString
      end if
    end repeat
    delete char -30000 of validFilesString
    return validFilesString
  else
    set allFilesInDataFolder to EMPTY
    set allFilesList to baFileList(pDataFolderPath, "*" & pFileNameExtension)
    set end to count(allFilesList)
    sort(allFilesList)
    repeat with i = 1 to end
      set thisFile to getAt(allFilesList, i)
      set end2 to length(thisFile) - 4
      put char 1 to end2 of thisFile & RETURN after allFilesInDataFolder
    end repeat
    delete char -30000 of allFilesInDataFolder
    return allFilesInDataFolder
  end if
end

on checkForChanges me
  if documentTouched then
    if not pCurrentFileName then
      storeFrameData(gObj2)
      if not (the pageLayoutList of gObj2 = [[1, 1, 0], 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0]) then
        set changesP to 1
      end if
    else
      set changesP to 1
    end if
  end if
  return changesP
end

on openFile me, fromDialog, theFileNum, filePathOverride
  if not fromDialog then
    if checkForChanges() then
      tell window 1
        displayDialog(7, #openFile, me)
      end tell
    else
      tell window 1
        displayDialog(9)
      end tell
    end if
  else
    if not theFileNum then
      tell window 1
        displayDialog(9)
      end tell
    else
      if voidp(filePathOverride) then
        set newPathName to pDataFolderPath & line theFileNum of pDataFileDirectoryContents
        set pLastDirectorySelection to theFileNum
      else
        set newPathName to filePathOverride
      end if
      set currentCastLib to the fileName of castLib 4
      set the fileName of castLib 4 to newPathName & pFileNameExtension
      if not (the type of member 13 of castLib 4 = #field) then
        set the fileName of castLib 4 to currentCastLib
        alert("CBA/2 internal error: This file happens to invalid!" & RETURN & RETURN & newPathName)
        exit
      end if
      set the itemDelimiter to gItemSeparator
      set dataString to the text of member 13 of castLib 4
      if not (item 3 of line 1 of dataString = pCharacterCode) then
        set the fileName of castLib 4 to currentCastLib
        alert("CBA/2 internal error: This file happens to be for a different character than" && pCharacterFolderName & "!")
        exit
      end if
      set fileCharLibVersion to value(item 4 of line 1 of dataString)
      set fileFileVersion to value(item 6 of line 1 of dataString)
      if voidp(fileFileVersion) then
        set fileFileVersion to 0
      end if
      if (fileCharLibVersion > pCharLibVersion) or (fileFileVersion > pFileVersion) then
        set the fileName of castLib 4 to currentCastLib
        alert("CBA/2 internal error: This file happens to in an newer format and cannot be opened!" & RETURN & RETURN & "characterLib:" && fileCharLibVersion & RETURN & "fileVersion:" && fileFileVersion)
        exit
      else
        if fileCharLibVersion < pCharLibVersion then
          alert("This file happens to be in an older format. Frame contents may look different than expected.")
        end if
      end if
      set openFileIsSample to value(item 5 of line 1 of dataString)
      if openFileIsSample then
        set pCurrentFileName to 0
      else
        set pCurrentFileName to getNthOfPath(newPathName, 0)
      end if
      clearPageLayout()
      clearFrameLayout()
      updateStage()
      set the imageTouched of gObj2 to 0
      set documentTouched to 0
      repeat with i = 1 to 12
        if the type of member i of castLib 4 = #bitmap then
          duplicate(member i of castLib 4, member (200 + i) of castLib 2)
          next repeat
        end if
        if not (the type of member (200 + i) of castLib 2 = #empty) then
          erase(member (200 + i) of castLib 2)
        end if
      end repeat
      deselectAll(gObj1)
      puppetSound(1, "openFile")
      makePageLayoutList(gObj2, dataString, fileFileVersion)
      set the fileName of castLib 4 to currentCastLib
    end if
  end if
end

on preSaveFile me
  set fileNameToCheck to the text of member "fileName"
  set startLookingFrom to offset(fileNameToCheck, pDataFileDirectoryContents)
  if startLookingFrom then
    set subString to line max(1, the number of lines in char 1 to startLookingFrom of pDataFileDirectoryContents - 1) to the number of lines in pDataFileDirectoryContents of pDataFileDirectoryContents
    set end to the number of lines in subString
    repeat with i = 1 to end
      if line i of subString = fileNameToCheck then
        set found to 1
        exit repeat
      end if
    end repeat
  end if
  if found then
    promptToOverwrite(script 1, VOID, 1)
  else
    terminateDialog(script "DialogScripts", #saveFile, me)
  end if
end

on saveFile me, fromDialog, newPathName, continueHandler, continueObj
  if not fromDialog then
    if pCurrentFileName = 0 then
      tell window 1
        displayDialog(10)
      end tell
    else
      saveFile(me, 1, pCurrentFileName)
    end if
  else
    if voidp(newPathName) and (pCurrentFileName = 0) then
      tell window 1
        displayDialog(10, continueHandler, continueObj)
      end tell
    else
      if not length(string(newPathName)) then
        set newPathName to pCurrentFileName
        if pCurrentFileName = 0 then
          alert("CBA/2 internal error: no fileName specified!")
        end if
      end if
      updateThumbNail(gObj2)
      if the imageTouched of gObj2 then
        updateThumbNail(gObj2, the currentFrameNo of gObj2)
      end if
      cursor(4)
      tell window 1
        displayDialog(11)
      end tell
      tell window 1
        cursor(4)
      end tell
      set newPathName to pDataFolderPath & newPathName
      set currentCastLib to the fileName of castLib 4
      set pCurrentFileName to getNthOfPath(newPathName, 0)
      repeat with i = 1 to 12
        if the type of member (200 + i) of castLib 2 = #bitmap then
          duplicate(member (200 + i) of castLib 2, member i of castLib 4)
          set the palette of member i of castLib 4 to -1
        end if
      end repeat
      new(#field, member 13 of castLib 4)
      set the text of member 13 of castLib 4 to convertPageLayoutList(gObj2)
      save(castLib 4, newPathName & pFileNameExtension)
      set the fileName of castLib 4 to currentCastLib
      if gPlatForm then
        OSSetFileInfo(newPathName, "CBA" & pCharacterCode, "CBA" & pCharacterCode)
      end if
      set the imageTouched of gObj2 to 0
      set documentTouched to 0
      set pDataFileDirectoryContents to getAllDataFiles()
      tell window 1
        terminateDialog(script 1)
      end tell
      cursor(0)
      if symbolp(continueHandler) then
        call(continueHandler, continueObj)
      end if
    end if
  end if
end

on quitProgram me, fromDialog
  if not checkForChanges() or fromDialog then
    set the timeoutScript to EMPTY
    set the keyDownScript to EMPTY
    if objectp(gScholasticObj) then
      repeat with i = 1 to 4
        sound close i
      end repeat
      go("splash")
    else
      go("credits")
    end if
  else
    tell window 1
      displayDialog(7, #quitProgram, me)
    end tell
  end if
end

on terminateProgram me
  writePrefFile(me, the pAuthorName of gObj2 & gItemSeparator & the volume of sound 1)
  go("lastFrame")
  if not voidp(gOldColorDepth) then
    if gPlatForm then
      set the colorDepth to gOldColorDepth
    else
      set currentWidth to baScreenInfo("width")
      set currentHeight to baScreenInfo("height")
      set isNotChanged to baSetDisplay(currentWidth, currentHeight, gOldColorDepth, "temp", 0)
    end if
    Del(10)
  end if
  if gPlatForm then
    puppetPalette("System - Mac")
  else
    puppetPalette("System - Win")
    writeRegistry()
  end if
  halt()
end

on writeRegistry me
  if baReadRegString(".CB" & pCharacterCode, EMPTY, EMPTY, "HKEY_CLASSES_ROOT") = EMPTY then
    set progID to "ComicBookArtist.doc." & pCharacterCode
    baWriteRegString(".CB" & pCharacterCode, EMPTY, progID, "HKEY_CLASSES_ROOT")
    baWriteRegString(progID & "\Shell\open\command", EMPTY, QUOTE & getNthOfPath(the moviePath) & "cba2_" & pCharacterCode & ".exe" & QUOTE & " " & QUOTE & "%1" & QUOTE, "HKEY_CLASSES_ROOT")
    baWriteRegString(progID & "\DefaultIcon", EMPTY, pDataFolderPath & pCharacterCode & "_icon", "HKEY_CLASSES_ROOT")
  end if
end
