property pColorMode, pDoc, pPrintMessage, pScaleFactor, pProgressObj
global gObj1, gObj2, gObj3, gObj5, gPlatForm, gObjList, gFontName, gDemoMode

on new me
  set the itemDelimiter to "/"
  set pPrintMessage to item 1 of line 3 of the text of member 1 of castLib 2
  set pScaleFactor to 2.37000000000000011
  set pColorMode to 1
  set pDoc to 0
  return me
end

on printFile me, fromDialog
  if not fromDialog then
    cursor(4)
    set pDoc to new(xtra("PrintOMatic"))
    if not objectp(pDoc) then
      cursor(0)
      if gPlatForm then
        tell window 1
          displayDialog(8)
        end tell
      else
        tell window 1
          displayDialog(17)
        end tell
      end if
      exit
    end if
    tell window 1
      displayDialog(6)
    end tell
    setDocumentName(pDoc, the pFileTitle of gObj2)
    cursor(0)
  else
    updateStage()
    storeFrameData(gObj2)
    if the imageTouched of gObj2 then
      updateThumbNail(gObj2, the currentFrameNo of gObj2)
    end if
    tell window 1
      displayDialog(5)
    end tell
    unloadMember()
    printComic()
  end if
end

on printComic me
  if the optionDown then
    puppetSound(1, "confirm")
    set printToPreview to 1
  end if
  set the mouseDownScript to "stopEvent"
  set the mouseUpScript to "stopEvent"
  set the mouseBlocked of getAt(gObjList, 1) to 1
  set pProgressObj to new(script "progressObj")
  set oldFileName to the fileName of castLib 4
  set the fileName of castLib 4 to "printLib"
  if not (the fileName of castLib 4 contains "printLib") then
    alert("CBA/2 internal error: cannot find printgraphics lib!")
    exit
  end if
  set characterCodeInfo to the name of member 1 of castLib 4
  if not (char 1 of characterCodeInfo = the pCharacterCode of gObj5) then
    set the fileName of castLib 4 to oldFileName
    alert("CBA/2 internal error: printLib seems to be of another character than " & the pCharacterFolderName of gObj5)
    exit
  end if
  set libVersion to value(char 3 to length(characterCodeInfo) of characterCodeInfo)
  if not integerp(libVersion) or not libVersion or not (libVersion = the pCharLibVersion of gObj5) then
    alert("PrintLib has other fileVersion than ScreenLib!" & RETURN & RETURN & "member 1")
    quit()
  end if
  castFX_init()
  set leftMargin to max(1, (getPaperWidth(pDoc) - 506) / 2)
  set topMargin to max(1, (getPaperHeight(pDoc) - 738) / 2)
  setMargins(pDoc, rect(leftMargin, topMargin, 0, 0))
  newPage(pDoc)
  set theFirstFrame to 0
  if gDemoMode then
    set demoMember to member "demo" of castLib 1
  end if
  repeat with i = 1 to 12
    if listp(getAt(the pageLayoutList of gObj2, i)) then
      if not theFirstFrame then
        set theFirstFrame to i
      end if
      set theLastFrame to i
    end if
  end repeat
  if not (the pCharacterCode of gObj5 = "g") then
    set theCopyRightFrame to theLastFrame
  else
    set theCopyRightFrame to theFirstFrame
  end if
  repeat with i = 1 to 12
    set thisFrameData to getAt(the pageLayoutList of gObj2, i)
    if integerp(thisFrameData) then
      next repeat
    else
      set abortPrint to processFrame(me, thisFrameData, i)
    end if
    if abortPrint then
      exit repeat
    end if
    if gDemoMode then
      set hOffset to (the width of member 300 of castLib 5 - the width of demoMember) / 2
      set vOffset to (the height of member 300 of castLib 5 - the height of demoMember) / 2
      CompositeTransparent(member 300 of castLib 5, demoMember, point(max(0, hOffset), max(0, vOffset)), 245, member 300 of castLib 5)
      if gPlatForm then
        set the picture of member 300 of castLib 5 to the picture of member 300 of castLib 5
      end if
      if castFX_Error() then
        alert("CFX error: problem with demoMember." & RETURN & RETURN & castFX_Error())
      end if
    end if
    if the width of member 300 of castLib 5 = 968 then
      set largeFrame to 1
    else
      set largeFrame to 0
    end if
    set l to (i - 1) mod 3 * 171
    set t to ((i - 1) / 3 * 171) + 38
    set frameRect to rect(l, t, l + 163 + (largeFrame * 172), t + 163)
    newFrame(pDoc, frameRect, 0)
    append(pDoc, member 300 of castLib 5)
    if i = theCopyRightFrame then
      if not (the pCharacterCode of gObj5 = "g") then
        set copyRightMember to member "copyRightNotice" of castLib 4
        newFrame(pDoc, rect(getAt(frameRect, 3) - integer(the width of copyRightMember * 0.17499999999999999), getAt(frameRect, 4) + 3, getAt(frameRect, 3), getAt(frameRect, 4) + 30), 0)
        append(pDoc, copyRightMember)
        next repeat
      end if
      set copyRightMember to member "copyRightNotice" of castLib 4
      newFrame(pDoc, rect(getAt(frameRect, 3) + 2, getAt(frameRect, 4) - integer(the height of copyRightMember * 0.17499999999999999), getAt(frameRect, 3) + 100, getAt(frameRect, 4)), 0)
      append(pDoc, copyRightMember)
    end if
  end repeat
  tell window 1
    terminateDialog(script 1, #Cancel, 0)
  end tell
  updateStage()
  if not abortPrint then
    set expandFactor to 2.89900000000000002
    set reductionFactor to 0.34549999999999997
    new(#bitmap, member 300 of castLib 5)
    set the text of member "textRenderField" to the pFileTitle of gObj2
    set the textSize of member "textRenderField" to integer(24 * expandFactor)
    set the picture of member 300 of castLib 5 to the picture of member "textRenderField"
    set titleHeight to the height of member 300 of castLib 5
    newFrame(pDoc, rect(0, 12, 300, 12 + (titleHeight * reductionFactor)), 0)
    append(pDoc, member 300 of castLib 5)
    set the text of member "textRenderField" to the pAuthorName of gObj2
    set the textSize of member "textRenderField" to integer(12 * expandFactor)
    set the picture of member 300 of castLib 5 to the picture of member "textRenderField"
    set vOffset to 11 + ((titleHeight - the height of member 300 of castLib 5) * reductionFactor)
    newFrame(pDoc, rect(504 - (the width of member 300 of castLib 5 * reductionFactor), vOffset, 505, 80), 0)
    append(pDoc, member 300 of castLib 5)
    setProgressMsg(pDoc, pPrintMessage && QUOTE & the pFileTitle of gObj2 & QUOTE & "...")
    if printToPreview then
      printPreview(pDoc)
    else
      print(pDoc)
    end if
  end if
  castFX_shutdown()
  set the fileName of castLib 4 to oldFileName
  set pDoc to 0
  set pProgressObj to 0
  unloadMember(191, the number of castMembers of castLib 1)
end

on processFrame me, theList, theFrameNo
  set frameSize to getAt(theList, 1)
  set borderColor to getAt(theList, 2)
  set frameData to getAt(theList, 3)
  duplicate(member (190 + frameSize), member 300 of castLib 5)
  if not (frameData = 0) then
    set numberOfSteps to checkSteps(me, frameData, frameSize) + 2
    initprogress(pProgressObj, theFrameNo, numberOfSteps)
    progress(pProgressObj)
    repeat with i = 1 to count(frameData)
      set graphicData to getAt(frameData, i)
      set hOffset to integer((getAt(getAt(graphicData, 1), 1) - 305 + ((frameSize - 1) * 105)) * pScaleFactor) + 3
      set vOffset to integer((getAt(getAt(graphicData, 1), 2) - 2) * pScaleFactor) + 3
      set graphicNo to getPropAt(frameData, i)
      set category to (graphicNo / 1000) + 1
      set flipped to not (graphicNo mod 2)
      set graphicNo to ((graphicNo - flipped) / 2) + 1
      set theCastLib to 4
      set balloonType to getAt(graphicData, 2)
      if balloonType then
        set graphicNo to ((getAt(the balloonMemberList of gObj3, balloonType) - flipped) / 2) + 1
        set balloonFieldMember to graphicNo + 20
      end if
      if max(intersect(the rect of member 300 of castLib 5, the rect of member graphicNo of castLib 4 + rect(hOffset, vOffset, hOffset, vOffset))) = 0 then
        if flipped then
          progress(pProgressObj)
        end if
        if balloonType then
          progress(pProgressObj)
        end if
        if min(hOffset, vOffset) < 0 then
          progress(pProgressObj)
        end if
        progress(pProgressObj)
        next repeat
      end if
      set theMemberToUnload to member graphicNo of castLib theCastLib
      if flipped then
        FlipHorz(member graphicNo of castLib theCastLib, member 299 of castLib 5)
        if gPlatForm then
          set the picture of member 299 of castLib 5 to the picture of member 299 of castLib 5
        end if
        if castFX_Error() then
          alert("CFX error: flipHor " & castFX_Error())
        end if
        set graphicNo to 299
        set theCastLib to 5
        if checkForInterrupt() then
          return 1
        end if
        progress(pProgressObj)
      end if
      if balloonType then
        set balloonProps to getAt(graphicData, 3)
        set fieldOffset to getLast(getAt(the allBalloonInfoList of gObj3, balloonType))
        set fieldPropList to getAt(getProp(getAt(the allBalloonInfoList of gObj3, balloonType), getAt(balloonProps, 1)), 2)
        if not gPlatForm then
          set the media of member balloonFieldMember of castLib 4 to the media of member balloonFieldMember of castLib 4
        end if
        set the text of member balloonFieldMember of castLib 4 to getAt(getAt(balloonProps, 4), 2)
        set the textFont of member balloonFieldMember of castLib 4 to gFontName
        set the backcolor of member balloonFieldMember of castLib 4 to 245
        set the textSize of member balloonFieldMember of castLib 4 to getAt(fieldPropList, 1)
        set the textHeight of member balloonFieldMember of castLib 4 to getAt(fieldPropList, 2)
        set the scrollTop of member balloonFieldMember of castLib 4 to getAt(fieldPropList, 3)
        new(#bitmap, member 298 of castLib 5)
        set the picture of member 298 of castLib 5 to the picture of member balloonFieldMember of castLib 4
        CompositeTransparent(member graphicNo of castLib theCastLib, member 298 of castLib 5, fieldOffset, 245, member 299 of castLib 5)
        if gPlatForm then
          set the picture of member 299 of castLib 5 to the picture of member 299 of castLib 5
        end if
        if castFX_Error() then
          alert("CFX error: compositeTr. " & castFX_Error())
        end if
        set graphicNo to 299
        set theCastLib to 5
        set hOffset to hOffset - (the width of member 299 of castLib 5 / 2)
        set vOffset to vOffset - (the height of member 299 of castLib 5 / 2)
        progress(pProgressObj)
      end if
      if min(hOffset, vOffset) < 0 then
        set cutRect to rect(point(abs(min(0, hOffset)), abs(min(0, vOffset))), point(the width of member graphicNo of castLib theCastLib - 1, the height of member graphicNo of castLib theCastLib))
        Extract(member graphicNo of castLib theCastLib, cutRect, member 299 of castLib 5)
        if gPlatForm then
          set the picture of member 299 of castLib 5 to the picture of member 299 of castLib 5
        end if
        if castFX_Error() then
          alert("CFX error: extract " & castFX_Error())
        end if
        set graphicNo to 299
        set theCastLib to 5
        if checkForInterrupt() then
          return 1
        end if
        progress(pProgressObj)
      end if
      CompositeTransparent(member 300 of castLib 5, member graphicNo of castLib theCastLib, point(max(0, hOffset), max(0, vOffset)), 245, member 300 of castLib 5)
      if gPlatForm then
        set the picture of member 300 of castLib 5 to the picture of member 300 of castLib 5
      end if
      if castFX_Error() then
        alert("CFX error: compositeTr.2 " & castFX_Error() & RETURN & RETURN & the freeBytes / 1024 && "/" && castFX_version() & RETURN & the rect of member 300 of castLib 5 && the rect of member graphicNo of castLib theCastLib)
      end if
      if checkForInterrupt() then
        return 1
      end if
      progress(pProgressObj)
      unloadMember(theMemberToUnload)
    end repeat
    progress(pProgressObj)
    CompositeTransparent(member 300 of castLib 5, member (190 + frameSize + (not borderColor * 2)) of castLib 1, point(0, 0), 0, member 300 of castLib 5)
    if gPlatForm then
      set the picture of member 300 of castLib 5 to the picture of member 300 of castLib 5
    end if
    progress(pProgressObj)
  else
    initprogress(pProgressObj, theFrameNo, 1)
  end if
  terminateProgress(pProgressObj)
  if not pColorMode then
    set theRect to the rect of member 300 of castLib 5 - [-1, -1, 2, 2]
    ReplaceAllColorsExcept(member 300 of castLib 5, 255, 0, theRect, member 300 of castLib 5)
    if gPlatForm then
      set the picture of member 300 of castLib 5 to the picture of member 300 of castLib 5
    end if
    if castFX_Error() then
      alert("CFX error: allClrExc. " & castFX_Error() & RETURN & RETURN & the freeBytes / 1024)
    end if
  end if
end

on checkSteps me, theList, frameSize
  repeat with i = count(theList) down to 1
    set total to total + 1
    set total to total + ((getPropAt(theList, i) mod 2) = 0)
    set graphicData to getAt(theList, i)
    set total to total + (min(getAt(graphicData, 1) - point(306 - ((frameSize - 1) * 105), 2)) < 0)
    set total to total + not (getAt(graphicData, 2) = 0)
    set total to total + (pColorMode = 0)
  end repeat
  return total
end

on changeColorMode me, theSprite, theNewMode
  if theNewMode then
    enable(sprite(theSprite + 2))
  else
    enable(sprite(theSprite - 2))
  end if
  disable(sprite(theSprite))
  set pColorMode to theNewMode
  updateStage()
end

on displayPageSetup me
  doPageSetup(pDoc)
end

on checkForInterrupt me
  tell window 1
    set x to the mouseDown
  end tell
  if x then
    tell window 1
      set y to rollOver(3) + rollOver(4)
    end tell
    if y then
      tell window 1
        repeat while the mouseDown
          set q to point(the mouseH, the mouseV)
          if rollOver(3) + rollOver(4) then
            mouseDown(sprite(4))
            next repeat
          end if
          mouseLeave(sprite(4))
        end repeat
        if not (the memberNum of sprite 4 = the myMemb of sprite(4)) then
          set abortPrinting to 1
        end if
        mouseLeave(sprite(4))
      end tell
    end if
  end if
  return abortPrinting
end
